#include "adc.h"

xQueueHandle xQueueADC0Result;

/**************************************************************************//**
 * @brief ADC0 interrupt handler
 *****************************************************************************/
void ADC0_IRQHandler(void)
{
	ADC_TypeDef *adc = ADC0;
	uint16_t cRx;
	portBASE_TYPE xHigherPriorityTaskWoken=pdFALSE;
	if (adc->IF & ADC_IF_SINGLE)
	{
		cRx = adc->SINGLEDATA;
		xQueueSendFromISR(xQueueADC0Result,&cRx,&xHigherPriorityTaskWoken);
		adc->CMD=ADC_CMD_SINGLESTOP;
		adc->IFC = 0xFF;
	}
	portEND_SWITCHING_ISR(xHigherPriorityTaskWoken);
}

void initADC(){
/* Amient Light sensor gives out values between 0.1 to 2V
 * Refference of 2.5V is used. 
 */
        DVK_enablePeripheral(DVK_AMBIENT);
	xQueueADC0Result = xQueueCreate( 1, ( unsigned portBASE_TYPE ) sizeof( uint16_t ) );
	CMU->HFPERCLKEN0 |= CMU_HFPERCLKEN0_ADC0;
	ADC_TypeDef *adc= ADC0;
	/* Clear all pending interrupts */
	adc->IFC = _ADC_IFC_MASK;
	adc->IEN = ADC_IEN_SINGLE;
	NVIC_SetPriority(ADC0_IRQn,7);
	/* Enable interrupt in Cortex Core */
	NVIC_ClearPendingIRQ(ADC0_IRQn);
	NVIC_EnableIRQ(ADC0_IRQn);

	DVK_enablePeripheral(DVK_I2C);
	ADC0->SINGLECTRL = ADC_SINGLECTRL_AT_256CYCLES|ADC_SINGLECTRL_INPUTSEL_CH5 | ADC_SINGLECTRL_REF_2V5;
	//CMU_ClockEnable(cmuClock_ADC0,0);		
}
