#include "checktiming.h"

#define RTCTICKFREQ (configRTCCLOCKFREQUENCY/((1<<configRTCDIVIDER)))

void LETIMER_init(){
	CMU->LFAPRESC0 &= ~_CMU_LFAPRESC0_LETIMER0_MASK;
	CMU->LFAPRESC0 |= _CMU_LFAPRESC0_LETIMER0_DIV32 << _CMU_LFAPRESC0_LETIMER0_SHIFT;
	CMU->LFACLKEN0 |= CMU_LFACLKEN0_LETIMER0;
	while (CMU->SYNCBUSY) ;
	NVIC_DisableIRQ( LETIMER0_IRQn );
	NVIC_ClearPendingIRQ( LETIMER0_IRQn );
	NVIC_EnableIRQ(LETIMER0_IRQn);
	NVIC_SetPriority(LETIMER0_IRQn,7);
	
	LETIMER0->IEN=LETIMER_IEN_UF;
	LETIMER0->COMP0 =0; //Count down to 0, at frequency 256Hz. Should take 511 seconds.
	LETIMER0->CMD = LETIMER_CMD_START;
	LETIMER0->IFC=LETIMER_IFC_UF;
	while(LETIMER0->SYNCBUSY);
}
extern unsigned int numberOfSleeps;
int underflows=0;
char pcOutput3[100];
int maxDiff=0;//Maximum change between two diffs
int previous=6;
extern unsigned int rtcOverflows;
void vCheckTiming( void *pvParameters )
{

  LETIMER_init();
  
  for(;;){
		vTaskDelay(5000/portTICK_RATE_MS);
		portTickType currentTick=xTaskGetTickCount();
		unsigned int tickFromLetimer = underflows<<16|(0xFFFF-LETIMER0->CNT);
		tickFromLetimer = ((uint64_t) tickFromLetimer * (uint64_t) configTICK_RATE_HZ ) / (uint64_t) (configRTCCLOCKFREQUENCY/32);
		int currentDiff = currentTick-tickFromLetimer;
		int diffFromPrev = currentDiff - previous;
		if(abs(diffFromPrev)>maxDiff){
			maxDiff = abs(diffFromPrev);
		}
		previous = currentDiff;
		int currentTickFromRTC =((uint64_t) rtcOverflows<<24 | RTC->CNT)* (uint64_t) configTICK_RATE_HZ/RTCTICKFREQ;		
		sprintf(pcOutput3,"timer: %d, %d, %d, %d, %d\r\n\0",currentTick,tickFromLetimer,currentDiff,maxDiff,numberOfSleeps);
		vSerialPutString(pcOutput3,strlen(pcOutput3));
  }
}

void LETIMER0_IRQHandler(){
	if(LETIMER0->IF & LETIMER_IF_UF){
		underflows++;
		LETIMER0->IFC = LETIMER_IFC_UF;
	}
}