/**************************************************************************//**
 * @file
 * @brief Energy Mode function prototypes
 * @author Energy Micro AS
 * @version 1.0.1
 ******************************************************************************
 * @section License
 * <b>(C) Copyright 2009 Energy Micro AS, http://www.energymicro.com</b>
 ******************************************************************************
 *
 * This source code is the property of Energy Micro AS. The source and compiled
 * code may only be used on Energy Micro "EFM32" microcontrollers.
 *
 * This copyright notice may not be removed from the source code nor changed.
 *
 * DISCLAIMER OF WARRANTY/LIMITATION OF REMEDIES: Energy Micro AS has no
 * obligation to support this Software. Energy Micro AS is providing the
 * Software "AS IS", with no express or implied warranties of any kind,
 * including, but not limited to, any implied warranties of merchantability
 * or fitness for any particular purpose or warranties against infringement
 * of any proprietary rights of a third party.
 *
 * Energy Micro AS will not be liable for any consequential, incidental, or
 * special damages, or any other relief, or for any claim by any third party,
 * arising from your use of this Software.
 *
 *****************************************************************************/

#ifndef _ENERGYMODES_H
#define _ENERGYMODES_H

#include "FreeRTOS.h"
#include "efm32.h"
#include "task.h"
#include "croutine.h"

/*Function used to enter energymode*/
void EM_Enter(unsigned char);

/*Used by the application to set what energymode to go to at runtime*/
void emtogoto();

/*This function is called by the freeRTOS idle task. It determines if and for
how long we are able to sleep, sets up the rtc to wake up the core, and returns
for how long it slept.*/
portTickType sleepWhileIdle();
#endif
