#include "measurement.h"

#if configUSE_TICKLESSIDLE == 0
	#define vTaskCanGoToEM(x) 
#endif 
/*Three functions to to some calculation on the Light values*/
static double prvMin(double * array);
static double prvMax(double * array);
static double prvAvg(double * array);
#define measurmentPOWERDELAY 1000
static char* createTemperatureString(TEMPSENS_Temp_TypeDef *);
/*Queue with ADC result*/
extern xQueueHandle xQueueADC0Result;

/*Array of ADC values*/
static double prvValues[10];

/*Used by booth tasks to store the string they want to send over LEUART*/
char pcOutput[150];

void vMeasurementLight( void *pvParameters )
{
        int receive = 0;
        portTickType xLastWakeTime;         
	CMU_ClockEnable(cmuClock_ADC0,1);	
        vTaskDelay(750);
        xLastWakeTime = xTaskGetTickCount(); 
	for( ;; )
	{   
		for(int i =0;i<10;i++){
		  	vTaskCanGoToEM(1);
			ADC0->CMD=ADC_CMD_SINGLESTART;
		  	xQueueReceive( xQueueADC0Result, &receive, portMAX_DELAY );
                        prvValues[i]= receive;                      
			vTaskCanGoToEM(2);
			vTaskDelayUntil(&xLastWakeTime,measurmentPOWERDELAY/portTICK_RATE_MS);
		}
                for(int i = 0;i<60;i++){
                  sprintf(pcOutput,"Light Level: max: %f, min: %f, avg: %f                                                                                          \r\n",prvMax(prvValues),prvMin(prvValues),prvAvg(prvValues));
                }
		vSerialPutString(pcOutput,strlen(pcOutput));

	}
}
void vMeasurementTemp( void *pvParameters )
{
        portTickType xLastWakeTime; 
	int stack = uxTaskGetStackHighWaterMark(NULL);
	TEMPSENS_Temp_TypeDef temp;
	int returnValue;
        vTaskDelay(250);
        xLastWakeTime = xTaskGetTickCount(); 
	for( ;; )
	{			  	
	  	vTaskCanGoToEM(1);
    	        returnValue= TEMPSENS_TemperatureGet(I2C0, TEMPSENS_DVK_ADDR,&temp);
		vTaskCanGoToEM(3);
		if(returnValue<0){
		  sprintf(pcOutput,"Temperature: invalid:\r\n");
		}else{
		  sprintf(pcOutput,"Temperature: %s                                                                                                       \r\n",createTemperatureString(&temp));
		}
		vSerialPutString(pcOutput,strlen(pcOutput));
		vTaskDelayUntil(&xLastWakeTime,measurmentPOWERDELAY/portTICK_RATE_MS);
	}
}


static double prvMin(double * array){
	double min = 10E37;
	for(int i = 0; i<10;i++){
		if(array[i]<min){
			min=array[i];
		}
	}
	return min;
}

static double prvMax(double * array){
	double max = 0;
	for(int i = 0; i<10;i++){
		if(array[i]>max){
			max=array[i];
		}
	}
	return max;
}

static double prvAvg(double * array){
	double sum = 0;
	for(int i = 0; i<10;i++){
		sum+=array[i];
	}
	return sum/10;
}

  	char text[8];
static char* createTemperatureString(TEMPSENS_Temp_TypeDef * temp){
  	int showFahrenheit = 0;
  /* Work with local copy in case conversion to Fahrenheit is required */
	TEMPSENS_Temp_TypeDef dtemp;
	dtemp = *temp;
	
	memset(text, ' ', sizeof(text) - 1);
	text[sizeof(text) - 1] = 0;
	text[7] = '\0';
	if (showFahrenheit)
	{
	  text[6] = 'F';
	
	TEMPSENS_Celsius2Fahrenheit(&dtemp);
	}
	else
	{
	text[6] = 'C';
	}
	
	/* Round temperature to nearest 0.5 */
	if (dtemp.f >= 0)
	{
	dtemp.i += (dtemp.f + 2500) / 10000;
	dtemp.f = (((dtemp.f + 2500) % 10000) / 5000) * 5000;
	}
	else
	{
	dtemp.i += (dtemp.f - 2500) / 10000;
	dtemp.f = (((dtemp.f - 2500) % 10000) / 5000) * 5000;
	}

	if ((dtemp.i < 0) || (dtemp.f < 0))
	{
	text[0] = '-';
	}
	else
	{
	text[0] = '+';
	}	
	/* 100s */
	if (abs(dtemp.i) >= 100)
	text[1] = '0' + (abs(dtemp.i) / 100);
	
	/* 10s */
	if (abs(dtemp.i) >= 10)
	text[2] = '0' + ((abs(dtemp.i) % 100) / 10);
	
	/* 1s */
	text[3] = '0' + (abs(dtemp.i) % 10);
	text[4] = '.';
	/* 0.1s */
	text[5] = '0' + (abs(dtemp.f) / 1000);
	return text;
}