#ifndef MEASUREMENT_H
#define MEASUREMENT_H

#include <stdio.h>

#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "dvk.h"
#include "efm32_cmu.h"

#include "efm32.h"
#include "serial.h"
#include "energymodes.h"
#include "i2cdrv.h"
#include "adc.h"
#include "tempsens.h"
#include <string.h>
#include <stdlib.h>

/**
 * Task that measures the light from the sensor on the DVK.
 * Uses the ADC to convert from analog to digital.
 * After 10 measurments, it writes som statistics to the LEUART.
 */
void vMeasurementLight( void *pvParameters );

/**
 * Task that reads the temperature via the I2C buss to the sensor on 
 * the DVK, and sends it over the LEUART.
 */
void vMeasurementTemp( void *pvParameters );

#endif