#include <stddef.h>
#include "freeRTOS.h"
#include "efm32.h"
#include "rtc.h"

#define RTC_FREQ    32768
void (*cb)(void) = NULL;


/*
 * The RTC interrupt does not realy have to do anything. 
 * It has already woken up the core from WFE, since the SEVONBEND bit is set in
 * the system control register.
 */
#if configUSE_TICKLESSIDLE==1
extern unsigned int rtcOverflows;
void RTC_IRQHandler(void)
{
	//RTC->CTRL &=~(RTC_CTRL_EN);
	if(RTC->IF & RTC_IF_OF){
		rtcOverflows++;
		RTC->IFC = RTC_IFC_OF;
	}
	RTC->IFC = RTC_IFC_COMP0;
}
#endif

void RTC_init(void)
{
	CMU->LFACLKEN0 |= CMU_LFACLKEN0_RTC;
	CMU->LFAPRESC0 &= ~_CMU_LFAPRESC0_RTC_MASK;
	CMU->LFAPRESC0 |= configRTCDIVIDER << _CMU_LFAPRESC0_RTC_SHIFT;
	while (CMU->SYNCBUSY) ;


	RTC->IEN = 0;
	RTC->IFC = RTC_IFC_COMP0|RTC_IFC_COMP1|RTC_IFC_OF;
	NVIC_DisableIRQ( RTC_IRQn );
	NVIC_ClearPendingIRQ( RTC_IRQn );
	NVIC_SetPriority(RTC_IRQn,7);
	RTC->COMP0 = 0x00FFFFFF;  
	RTC->COMP1 = 0x00FFFFFF;
	while (RTC->SYNCBUSY) ;
	/* Restart counter */
	RTC->CTRL = RTC_CTRL_EN;
	
	/* Wait until all registers are updated */
	while (RTC->SYNCBUSY) ;
 
	/* Enable interrupt */
	NVIC_EnableIRQ(RTC_IRQn);
	RTC->IEN = RTC_IEN_COMP0 | RTC_IEN_OF; //Comp1 is just for debugging overflow.
	/* Start Counter */ 
}